diff --git a/ptrace.c b/ptrace.c
index 4b5d9295..7a9e4062 100644
--- a/ptrace.c
+++ b/ptrace.c
@@ -83,7 +83,7 @@
 static struct {
     uint8_t cache[MAX_PEEKBUF_SIZE];  /* read from ptrace()  */
     unsigned size;              /* number of entries (in bytes) */
-    char *base;                 /* base address of cached region */
+    const char *base;           /* base address of cached region */
     pid_t pid;                  /* what pid this applies to */
 } peekbuf;
 
@@ -128,12 +128,12 @@ bool sm_detach(pid_t target)
  * consecutive addresses.
  */
 
-bool sm_peekdata(pid_t pid, void *addr, value_t * result)
+bool sm_peekdata(pid_t pid, const void *addr, value_t * result)
 {
-    char *reqaddr = addr;
+    const char *reqaddr = addr;
     int i, j;
     int shift_size1 = 0, shift_size2 = 0;
-    char *last_address_gathered = 0;
+    const char *last_address_gathered = NULL;
 
     assert(peekbuf.size <= MAX_PEEKBUF_SIZE);
     assert(result != NULL);
@@ -186,7 +186,7 @@ bool sm_peekdata(pid_t pid, void *addr, value_t * result)
     
     for (i = 0; i < shift_size1; i += sizeof(long))
     {
-        char *ptrace_address = peekbuf.base + peekbuf.size;
+        const char *ptrace_address = peekbuf.base + peekbuf.size;
         long ptraced_long = ptrace(PTRACE_PEEKDATA, pid, ptrace_address, NULL);
 
         /* check if ptrace() succeeded */
diff --git a/scanmem.h b/scanmem.h
index f2a11d61..daf7378d 100644
--- a/scanmem.h
+++ b/scanmem.h
@@ -112,7 +112,7 @@ bool sm_checkmatches(globals_t *vars, scan_match_type_t match_type,
                      const uservalue_t *uservalue);
 bool sm_searchregions(globals_t *vars, scan_match_type_t match_type,
                       const uservalue_t *uservalue);
-bool sm_peekdata(pid_t pid, void *addr, value_t *result);
+bool sm_peekdata(pid_t pid, const void *addr, value_t *result);
 bool sm_attach(pid_t target);
 bool sm_read_array(pid_t target, void *addr, char *buf, int len);
 bool sm_write_array(pid_t target, void *addr, const void *data, int len);
diff --git a/scanroutines.c b/scanroutines.c
index 5a84f359..a4219d30 100644
--- a/scanroutines.c
+++ b/scanroutines.c
@@ -29,7 +29,7 @@
 
 
 /* for convenience */
-#define SCAN_ROUTINE_ARGUMENTS (const value_t *new_value, const value_t *old_value, const uservalue_t *user_value, match_flags *saveflags, void *address) 
+#define SCAN_ROUTINE_ARGUMENTS (const value_t *new_value, const value_t *old_value, const uservalue_t *user_value, match_flags *saveflags, const void *address)
 int (*sm_scan_routine) SCAN_ROUTINE_ARGUMENTS;
 
 #define VALUE_COMP(a,b,field,op)    (((a)->flags.field && (b)->flags.field) && (get_##field(a) op get_##field(b)))
diff --git a/scanroutines.h b/scanroutines.h
index 3e56de7d..89d43f48 100644
--- a/scanroutines.h
+++ b/scanroutines.h
@@ -64,7 +64,7 @@ typedef enum {
 /* NOTE: saveflag must be set to 0, since only useful bits are set, but extra bits are not cleared! */
 /*       address is pointing to new_value in TARGET PROCESS MEMORY SPACE, used when searching for a byte array */
 /* return the number of bytes needed to store old_value, 0 for not matched */
-typedef int (*scan_routine_t)(const value_t *new_value, const value_t *old_value, const uservalue_t *user_value, match_flags *saveflag, void *address);
+typedef int (*scan_routine_t)(const value_t *new_value, const value_t *old_value, const uservalue_t *user_value, match_flags *saveflag, const void *address);
 extern scan_routine_t sm_scan_routine;
 
 /* 
